//caps.h:

/*
 *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2014
 *
 *  This file is part of libroar a part of RoarAudio,
 *  a cross-platform sound system for both, home and professional use.
 *  See README for details.
 *
 *  This file is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 3
 *  as published by the Free Software Foundation.
 *
 *  libroar is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this software; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 *
 *  NOTE for everyone want's to change something and send patches:
 *  read README and HACKING! There a addition information on
 *  the license of this document you need to read before you send
 *  any patches.
 *
 *  NOTE for uses of non-GPL (LGPL,...) software using libesd, libartsc
 *  or libpulse*:
 *  The libs libroaresd, libroararts and libroarpulse link this lib
 *  and are therefore GPL. Because of this it may be illigal to use
 *  them with any software that uses libesd, libartsc or libpulse*.
 */

#ifndef _LIBROARCAPS_H_
#define _LIBROARCAPS_H_

#include "libroar.h"

struct roar_caps {
 int version;
 int type;
 int flags;
 void * data;
 size_t len;
};

struct roar_stds {
 size_t stds_len;
 uint32_t * stds;
};

const struct roar_stds * libroar_libstds(void);

int roar_caps_to_msg(struct roar_message * mes,  struct roar_caps    * caps, void ** data);
int roar_caps_from_msg(struct roar_caps  * caps, struct roar_message * mes,  void  * data);

int roar_caps_stds(struct roar_connection * con, struct roar_stds ** out, struct roar_stds * in, int flags);

struct roar_stds * roar_stds_new(size_t len);
int roar_stds_free(struct roar_stds * stds);

int roar_stds_str2vendor(const char * vendor);
const char * roar_stds_vendor2str(const int vendor);

#endif

//ll
